package be.iminds.ilabt.jfed.experimenter_gui.slice.espec.view;

import be.iminds.ilabt.jfed.experimenter_gui.slice.espec.model.ESpecLogModel;
import be.iminds.ilabt.jfed.experimenter_gui.slice.espec.model.ESpecStateItem;
import javafx.application.Platform;
import javafx.collections.ListChangeListener;
import javafx.scene.control.ScrollPane;
import javafx.scene.layout.HBox;
import javafx.scene.layout.Pane;

import javax.annotation.Nonnull;
import java.util.ArrayList;
import java.util.List;


public class ESpecStateList extends ScrollPane {
    private final Pane contentPane;
    private final ESpecLogModel eSpecLogModel;

    public ESpecStateList(ESpecLogModel eSpecLogModel) {
        this.eSpecLogModel = eSpecLogModel;

        this.contentPane = new HBox();
        contentPane.setMinHeight(60.0);
        contentPane.setPrefHeight(60.0);
        contentPane.setMaxHeight(60.0);
        setContent(contentPane);

        setMinHeight(60.0);
        setVbarPolicy(ScrollBarPolicy.NEVER);
        setHbarPolicy(ScrollBarPolicy.AS_NEEDED);

        Platform.runLater(() -> {
            eSpecLogModel.getESpecStateItems().addListener((ListChangeListener<ESpecStateItem>) c -> {
                while (c.next()) {
                    if (c.wasAdded()) {
                        for (ESpecStateItem i : c.getAddedSubList()) {
                            addESpecStateItem(i);
                        }
                    }
                }
            });
            List<ESpecStateItem> origItems = new ArrayList(eSpecLogModel.getESpecStateItems());
            for (ESpecStateItem oi: origItems)
                addESpecStateItem(oi);
        });
    }

    public void addESpecStateItem(@Nonnull ESpecStateItem eSpecStateItem) {
        Platform.runLater(() -> {
            ESpecStateButton button = new ESpecStateButton(eSpecStateItem);
            button.setOnClickedHandler((clickedESpecStateItem) -> {
                eSpecLogModel.setSelectedESpecStateItem(clickedESpecStateItem);
            });
            contentPane.getChildren().add(button);
        });
    }
}
